/** @license React vundefined
 * react-noop-renderer-flight-client.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';

var ReactFlightClient = require('react-flight');

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */

var _ReactFlightClient = ReactFlightClient({
  supportsBinaryStreams: false
}),
    createResponse = _ReactFlightClient.createResponse,
    getModelRoot = _ReactFlightClient.getModelRoot,
    processStringChunk = _ReactFlightClient.processStringChunk,
    complete = _ReactFlightClient.complete;

function read(source) {
  var response = createResponse(source);

  for (var i = 0; i < source.length; i++) {
    processStringChunk(response, source[i], 0);
  }

  complete(response);
  return getModelRoot(response);
}

var ReactNoopFlightClient = {
  read: read
};

var ReactNoopFlightClient$1 = ({
  'default': ReactNoopFlightClient
});

function getCjsExportFromNamespace (n) {
	return n && n.default || n;
}

var ReactNoopFlightClient$2 = getCjsExportFromNamespace(ReactNoopFlightClient$1);

// TODO: decide on the top-level export form.
// This is hacky but makes it work with both Rollup and Jest.


var flightClient = ReactNoopFlightClient$2.default || ReactNoopFlightClient$2;

module.exports = flightClient;
