/** @license React vundefined
 * react-noop-renderer-flight-server.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';

var ReactFlightServer = require('react-server/flight');

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
var ReactNoopFlightServer = ReactFlightServer({
  scheduleWork: function (callback) {
    callback();
  },
  beginWriting: function (destination) {},
  writeChunk: function (destination, buffer) {
    destination.push(Buffer.from(buffer).toString('utf8'));
  },
  completeWriting: function (destination) {},
  close: function (destination) {},
  flushBuffered: function (destination) {},
  convertStringToBuffer: function (content) {
    return Buffer.from(content, 'utf8');
  },
  formatChunkAsString: function (type, props) {
    return JSON.stringify({
      type: type,
      props: props
    });
  },
  formatChunk: function (type, props) {
    return Buffer.from(JSON.stringify({
      type: type,
      props: props
    }), 'utf8');
  },
  renderHostChildrenToString: function (children) {
    throw new Error('The noop rendered do not support host components');
  }
});

function render(model) {
  var destination = [];
  var request = ReactNoopFlightServer.createRequest(model, destination);
  ReactNoopFlightServer.startWork(request);
  return destination;
}

var ReactNoopFlightServer$1 = {
  render: render
};

var ReactNoopFlightServer$2 = ({
  'default': ReactNoopFlightServer$1
});

function getCjsExportFromNamespace (n) {
	return n && n.default || n;
}

var ReactNoopFlightServer$3 = getCjsExportFromNamespace(ReactNoopFlightServer$2);

// TODO: decide on the top-level export form.
// This is hacky but makes it work with both Rollup and Jest.


var flightServer = ReactNoopFlightServer$3.default || ReactNoopFlightServer$3;

module.exports = flightServer;
