/** @license React vundefined
 * react-noop-renderer-server.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

'use strict';

var ReactFizzStreamer = require('react-server');

/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 */
var ReactNoopServer = ReactFizzStreamer({
  scheduleWork: function (callback) {
    callback();
  },
  beginWriting: function (destination) {},
  writeChunk: function (destination, buffer) {
    destination.push(JSON.parse(Buffer.from(buffer).toString('utf8')));
  },
  completeWriting: function (destination) {},
  close: function (destination) {},
  flushBuffered: function (destination) {},
  convertStringToBuffer: function (content) {
    return Buffer.from(content, 'utf8');
  },
  formatChunkAsString: function (type, props) {
    return JSON.stringify({
      type: type,
      props: props
    });
  },
  formatChunk: function (type, props) {
    return Buffer.from(JSON.stringify({
      type: type,
      props: props
    }), 'utf8');
  }
});

function render(children) {
  var destination = [];
  var request = ReactNoopServer.createRequest(children, destination);
  ReactNoopServer.startWork(request);
  return destination;
}

var ReactNoopServer$1 = {
  render: render
};

var ReactNoopServer$2 = ({
  'default': ReactNoopServer$1
});

function getCjsExportFromNamespace (n) {
	return n && n.default || n;
}

var ReactNoopServer$3 = getCjsExportFromNamespace(ReactNoopServer$2);

// TODO: decide on the top-level export form.
// This is hacky but makes it work with both Rollup and Jest.


var server = ReactNoopServer$3.default || ReactNoopServer$3;

module.exports = server;
